<?php

	if(!isset($_SESSION)) {session_start();}

	/*

	 * Script:    DataTables server-side script for PHP and MySQL

	 * Copyright: 2010 - Allan Jardine

	 * License:   GPL v2 or BSD (3-point)

	 */

	

	/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

	 * Easy set variables

	 */

	

	/* Array of database columns which should be read and sent back to DataTables. Use a space where

	 * you want to insert a non-database field (for example a counter or static image)

	 */

	$aColumns = array( 'device_key','device_name','trolley_id','picklist','device_status','push_picklist','remove_picklist','delete_device');

	

//$aColumnsFilter = array( 'product_code', 'product_ref',  'product_name', 'product_price', 'product_sale_price');

	

	/* Indexed column (used for fast and accurate table cardinality) */

	$sIndexColumn = "device_key";

	

	/* DB table to use */

	$sTable = "devices_view";

	

	/* Database connection information */

	include("repcon.php");

	

	/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

	 * If you just want to use the basic configuration for DataTables with PHP server-side, there is

	 * no need to edit below this line

	 */

	

	/* 

	 * MySQL connection

	 */

$gaSql['link'] = mysqli_connect($gaSql['server'], $gaSql['user'], $gaSql['password']) or

die('Could not open connection to server');



mysqli_select_db($gaSql['link'], $gaSql['db']) or

die('Could not select database ' . $gaSql['db']);

	

	

	/* 

	 * Paging

	 */

$sLimit = "";

if (isset($_GET['iDisplayStart']) && $_GET['iDisplayLength'] != '-1') {

    $sLimit = "LIMIT " . mysqli_real_escape_string($gaSql['link'], $_GET['iDisplayStart']) . ", " .

        mysqli_real_escape_string($gaSql['link'], $_GET['iDisplayLength']);

}



/*

 * Ordering

 */

if (isset($_GET['iSortCol_0'])) {

    $sOrder = "ORDER BY  ";

    for ($i = 0; $i < intval($_GET['iSortingCols']); $i++) {

        if ($_GET['bSortable_' . intval($_GET['iSortCol_' . $i])] == "true") {

            $sOrder .= $aColumns[intval($_GET['iSortCol_' . $i])] . "

				 	" . mysqli_real_escape_string($gaSql['link'], $_GET['sSortDir_' . $i]) . ", ";

        }

    }



    $sOrder = substr_replace($sOrder, "", -2);

    if ($sOrder == "ORDER BY") {

        $sOrder = "";

    }

}

	

	/* 

	 * Filtering

	 * NOTE this does not match the built-in DataTables filtering which does it

	 * word by word on any field. It's possible to do here, but concerned about efficiency

	 * on very large tables, and MySQL's regex functionality is very limited

	 */

	// $search_category = $_GET['search_category'];

	

	// $srch = $_GET['sSearch'];

	// $cdate = $_REQUEST["cdate"];

	// $edate = $_REQUEST["edate"];

	// $status = $_REQUEST["status"];

	// $courier_name = $_REQUEST["courier_name"];

	// if($courier_name == 'MNP'){$courier_name = "M&P";}

	// $sWhere = "WHERE order_date between str_to_date('$cdate','%d/%m/%Y') and str_to_date('$edate','%d/%m/%Y')";

	

	// if ($status == "1" )

	// {$sWhere .= " AND picklist_id IS NOT NULL ";}

	

	// if ($status == "2" )

	// {$sWhere .= " AND picklist_id NULL ";}

	

	// if($courier_name != '0'){

	//  $sWhere .= " AND courier_name = '$courier_name' ";   

	    

	// }

	

	//$sWhere = " WHERE";

	

	//$sWhere = " WHERE device_key  NOT IN ('5205dc425760e3c0','c718bf4881dd78e4')";

	

	if ( $_GET['sSearch'] != "" )

	{

	$sWhere = "WHERE (device_key like '%$srch%' OR device_name like '%$srch%' OR trolley_id like '%$srch%' OR device_type like '%$srch%' OR picklist like '%$srch%' OR device_status like '%$srch%') ";

		

	}

	

	

/* Individual column filtering */

for ($i = 0; $i < count($aColumns); $i++) {

    if (isset($_GET['bSearchable_' . $i]) && $_GET['bSearchable_' . $i] == "true" && $_GET['sSearch_' . $i] != '') {

        if ($sWhere == "") {

            $sWhere = "WHERE ";

        } else {

            $sWhere .= " AND ";

        }

        $sWhere .= $aColumns[$i] . " LIKE '%" . mysqli_real_escape_string($gaSql['link'], $_GET['sSearch_' . $i]) . "%' ";

    }

}

	

	

	/*

	 * SQL queries

	 * Get data to display

	 */

	$sQuery = "

		SELECT SQL_CALC_FOUND_ROWS ".str_replace(" , ", " ", implode(", ", $aColumns))."

		FROM   $sTable

		$sWhere

		$sOrder

		$sLimit

	";

	$rResult = mysqli_query($gaSql['link'], $sQuery) or die(mysqli_error($gaSql['link']));

	



/* Data set length after filtering */

$sQuery = "

		SELECT FOUND_ROWS()

	";

$rResultFilterTotal = mysqli_query($gaSql['link'], $sQuery) or die(mysqli_error($gaSql['link']));

$aResultFilterTotal = mysqli_fetch_array($rResultFilterTotal);

$iFilteredTotal = $aResultFilterTotal[0];



/* Total data set length */

$sQuery = "

		SELECT COUNT(" . $sIndexColumn . ")

		FROM   $sTable

	";

$rResultTotal = mysqli_query($gaSql['link'], $sQuery) or die(mysqli_error($gaSql['link']));

$aResultTotal = mysqli_fetch_array($rResultTotal);

$iTotal = $aResultTotal[0];

	

	

	/*

	 * Output

	 */

	$output = array(

		"sEcho" => intval($_GET['sEcho']),

		"iTotalRecords" => $iTotal,

		"iTotalDisplayRecords" => $iFilteredTotal,

		"aaData" => array()

	);

	

	while ( $aRow = mysqli_fetch_array( $rResult ) )

	{

		$row = array();

		for ( $i=0 ; $i<count($aColumns) ; $i++ )

		{

			

			$push = '';

$pick = '';

$list = '';  

$exp = explode(',',$aRow[ $aColumns[3] ]);

foreach($exp as $value){

	$product_query = mysqli_query($gaSql['link'], "SELECT count(*) as order_count FROM `inward_detail` Where picklist_id = '".$value."'" ) or die(mysqli_error());

   $product_run = mysqli_fetch_assoc($product_query);

					

					$pick.= "<a href='javascript:void(0);' onclick='Removepicklist(\"".$value."\", event);' title='Removepicklist'>Remove picklist(".$value.")</a><br/>";	

                    $list.= $value." -- SkuOut ( ".$product_run['order_count']." )<br/>";

						if($product_run['order_count'] == '0'){

						$push.= "<a href='javascript:void(0);' onclick='PushOrder(\"".$value."\", event);' title='Push Order'>Push Picklist(".$value.")</a><br/>"; 

						}else{

						$push.=	$value.'<br/>';

						}

				}

			if( $aColumns[$i] == "push_picklist")

			{

				//query for product details 

				

				

					

					$row[] = $push;

			

			}

			else if( $aColumns[$i] == "remove_picklist")

			{

				 

						

					$row[] = $pick;

			

			}

			else if( $aColumns[$i] == "delete_device")

			{

				

					$cnlist = "<a href='javascript:void(0);' onclick='Deletedevice(\"".$aRow[ $aColumns[0] ]."\",\"".$aRow[ $aColumns[3] ]."\", event);' title='Deletedevice'>Delete Device</a>

						"; 

						

					$row[] = $cnlist;

			

			}

			else if( $aColumns[$i] == "picklist")

			{

				

				$row[] = $list;

			}

			else if ( $aColumns[$i] != ' ')

			{

				

				$row[] = $aRow[ $aColumns[$i] ];

			}

		}

		$output['aaData'][] = $row;

	}

	

	echo json_encode( $output );

?>