<?php
	if(!isset($_SESSION)) {session_start();}
	/*
	 * Script:    DataTables server-side script for PHP and MySQL
	 * Copyright: 2010 - Allan Jardine
	 * License:   GPL v2 or BSD (3-point)
	 */
	
	/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
	 * Easy set variables
	 */
	
	/* Array of database columns which should be read and sent back to DataTables. Use a space where
	 * you want to insert a non-database field (for example a counter or static image)
	 */
	$aColumns = array( 'order_date','picklist_complete_time','customer_order_id','newno','customer_billing_name','customer_order_date',
	'customer_bill_city','sku_id','sku_name','picklist_id','bintype','payment_type','courier_name','codamount','order_status','customer_order_quantity','bincount','cancel_status','dispatch_status','action','tracking_status');
	
//$aColumnsFilter = array( 'product_code', 'product_ref',  'product_name', 'product_price', 'product_sale_price');
	
	/* Indexed column (used for fast and accurate table cardinality) */
	$sIndexColumn = "newno";
	
	/* DB table to use */
	$sTable = "orderlist_status_view";
	
	/* Database connection information */
	include("repcon.php");
	
	/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
	 * If you just want to use the basic configuration for DataTables with PHP server-side, there is
	 * no need to edit below this line
	 */
	
	/* 
	 * MySQL connection
	 */
$gaSql['link'] = mysqli_connect($gaSql['server'], $gaSql['user'], $gaSql['password']) or

die('Could not open connection to server');



mysqli_select_db($gaSql['link'], $gaSql['db']) or

die('Could not select database ' . $gaSql['db']);





/*

 * Paging

 */

$sLimit = "";

if (isset($_GET['iDisplayStart']) && $_GET['iDisplayLength'] != '-1') {

    $sLimit = "LIMIT " . mysqli_real_escape_string($gaSql['link'], $_GET['iDisplayStart']) . ", " .

        mysqli_real_escape_string($gaSql['link'], $_GET['iDisplayLength']);

}



/*

 * Ordering

 */

if (isset($_GET['iSortCol_0'])) {

    $sOrder = "ORDER BY  ";

    for ($i = 0; $i < intval($_GET['iSortingCols']); $i++) {

        if ($_GET['bSortable_' . intval($_GET['iSortCol_' . $i])] == "true") {

            $sOrder .= $aColumns[intval($_GET['iSortCol_' . $i])] . "

				 	" . mysqli_real_escape_string($gaSql['link'], $_GET['sSortDir_' . $i]) . ", ";

        }

    }



    $sOrder = substr_replace($sOrder, "", -2);

    if ($sOrder == "ORDER BY") {

        $sOrder = "";

    }

}



	

	

	/* 

	 * Filtering

	 * NOTE this does not match the built-in DataTables filtering which does it

	 * word by word on any field. It's possible to do here, but concerned about efficiency

	 * on very large tables, and MySQL's regex functionality is very limited

	 */

	//$search_category = $_GET['search_category'];
	
	/* 
	 * Filtering
	 * NOTE this does not match the built-in DataTables filtering which does it
	 * word by word on any field. It's possible to do here, but concerned about efficiency
	 * on very large tables, and MySQL's regex functionality is very limited
	 */
	$search_category = $_GET['search_category'];
	
	$srch = $_GET['sSearch'];
	$cdate = $_REQUEST["cdate"];
	$edate = $_REQUEST["edate"];
	$status = $_REQUEST["status"];
	
	$dispatch_status = $_REQUEST["dispatch_status"];
	
	if($courier_name == 'MNP'){$courier_name = "M&P";}
	
	$sWhere = "WHERE order_date between '$cdate' and '$edate'";
	
	if ($status != '0')
	{$sWhere .= " AND order_status = '$status' ";}
	
	if ($dispatch_status != '0')
	{$sWhere .= " AND dispatch_status = '$dispatch_status' ";}
	
	
	
	if ( $_GET['sSearch'] != "" )
	{
	$sWhere .= " AND (order_status like '%$srch%' OR order_date like '%$srch%' OR picklist_complete_time like '%$srch%' OR customer_order_id like '%$srch%' OR newno like '%$srch%' OR customer_billing_name like '%$srch%' OR customer_bill_city like '%$srch%' OR customer_order_quantity like '%$srch%' OR picklist_id like '%$srch%' OR bintype like '%$srch%' OR payment_type like '%$srch%' OR courier_name like '%$srch%' OR codamount like '%$srch%' OR cancel_status like '%$srch%' OR dispatch_status like '%$srch%') ";
		
	}
	
	
	/* Individual column filtering */

for ($i = 0; $i < count($aColumns); $i++) {

    if (isset($_GET['bSearchable_' . $i]) && $_GET['bSearchable_' . $i] == "true" && $_GET['sSearch_' . $i] != '') {

        if ($sWhere == "") {

            $sWhere = "WHERE ";

        } else {

            $sWhere .= " AND ";

        }

        $sWhere .= $aColumns[$i] . " LIKE '%" . mysqli_real_escape_string($gaSql['link'], $_GET['sSearch_' . $i]) . "%' ";

    }

}



	

	

	/*

	 * SQL queries

	 * Get data to display

	 */

	$sQuery = "

		SELECT SQL_CALC_FOUND_ROWS " . str_replace(" , ", " ", implode(", ", $aColumns)) . "

		FROM   $sTable

		$sWhere

		$sOrder

		$sLimit

	";

	

	//echo $sQuery;

	

$rResult = mysqli_query($gaSql['link'], $sQuery) or die(mysqli_error($gaSql['link']));

	



/* Data set length after filtering */

$sQuery = "

		SELECT FOUND_ROWS()

	";

$rResultFilterTotal = mysqli_query($gaSql['link'], $sQuery) or die(mysqli_error($gaSql['link']));

$aResultFilterTotal = mysqli_fetch_array($rResultFilterTotal);

$iFilteredTotal = $aResultFilterTotal[0];



/* Total data set length */

$sQuery = "

		SELECT COUNT(" . $sIndexColumn . ")

		FROM   $sTable

	";

$rResultTotal = mysqli_query($gaSql['link'], $sQuery) or die(mysqli_error($gaSql['link']));

$aResultTotal = mysqli_fetch_array($rResultTotal);

$iTotal = $aResultTotal[0];



	

	

	/*

	 * Output

	 */

	$output = array(

		"sEcho" => intval($_GET['sEcho']),

		"iTotalRecords" => $iTotal,

		"iTotalDisplayRecords" => $iFilteredTotal,

		"aaData" => array()

	);

	

	while ( $aRow = mysqli_fetch_array( $rResult ) )

	{
		$row = array();
		for ( $i=0 ; $i<count($aColumns) ; $i++ )
		{
		
		     if( $aColumns[$i] == "bincount")
			{
				//query for product details 
				
					$product_query = mysqli_query( $gaSql['link'], "SELECT count(order_bintype) as order_count FROM `inward_detail` Where order_bintype = '{$aRow[ $aColumns[10] ]}' and picklist_id = '{$aRow[ $aColumns[9] ]}'" ) or die(mysql_error());
					$product_run = mysqli_fetch_assoc($product_query);
					
						$pickc = "<span style='background-color:green,color:white'>".(($product_run['order_count']))."</span>";
				       
				
					
					$row[] = $pickc;
			
			}
			
			
			else if( $aColumns[$i] == "action")
			{
				//query for product details 
				
					
						$cnlist = "<a href='javascript:void(0);' onclick='CNPrint(\"".$aRow[ $aColumns[3] ]."\",\"".$courier_id."\",\"".$product_run['courier_name']."\",\"".$apikey."\");' title='Print CN'>Print CN</a>
						<a href='javascript:void(0);' onclick='InvoicePrint(\"".$aRow[ $aColumns[3] ]."\", event);' title='Print'>Print Invoices</a>";
				     
					 /*if($product_run['order_count'] == 0){
						$cnlist.= "<br/><a href='javascript:void(0);' onclick='PushOrder(\"".$aRow[ $aColumns[9] ]."\",\"".$aRow[ $aColumns[3] ]."\", event);' title='Push Order'>Push Order</a>
						"; 
					 }

					 $cnlist.= "<br/><a href='javascript:void(0);' onclick='EditOrder(\"".$aRow[ $aColumns[9] ]."\",\"".$aRow[ $aColumns[3] ]."\", event);' title='Edit Order'>Edit Order</a>
						"; */
				
					
					$row[] = $cnlist;
			
			}
			
			
			
			else
			
			 if ( $aColumns[$i] != ' ')
			{
				
				$row[] = $aRow[ $aColumns[$i] ];
			}
		}
		$output['aaData'][] = $row;
	}
	
	echo json_encode( $output );
?>